/** 
 * Rebar - Reading Progress Bar for WordPress, exclusively on Envato Market: https://1.envato.market/rebar-wp
 * @encoding     UTF-8
 * @version      1.0.2
 * @copyright    Copyright (C) 2019 Merkulove ( https://merkulov.design/ ). All rights reserved.
 * @license      Envato Standard License https://1.envato.market/KYbje
 * @author       Alexandr Khmelnytsky ( info@alexander.khmelnitskiy.ua )
 * @support      dmitry@merkulov.design
 **/

/**
 * Widget assignments
 */
jQuery(function($) {
    "use strict";

    /** INPUT which will save the settings */
    var assignInput = jQuery("#md-assignInput");
    
    /**
     * Read assignments settings
     */
    function md_readSettings () {
        
        // Get assignments from field
        var aConf = '';
        try {
            
            var aConfJson = jQuery(assignInput).val();
            aConfJson = aConfJson.replace(/\|/g, '"');
            aConf = JSON.parse(aConfJson);
            
            // Matching Method
            var matchingMethod = aConf.matchingMethod;
            jQuery("#md-assign-box .md-matching-method .md-button-group .md-button").removeClass("md-active");
            if(matchingMethod == 0){ jQuery("#md-assign-box .md-matching-method .md-button-group .md-all").addClass("md-active"); }
            if(matchingMethod == 1){ jQuery("#md-assign-box .md-matching-method .md-button-group .md-any").addClass("md-active"); }
            
            // WordPress Content
            var WPContent = aConf.WPContent;
            var WPContentVal = aConf.WPContentVal + '';
            jQuery("#md-assign-box .md-wp-content .md-button-group .md-button").removeClass("md-active");
            if(WPContent == 0){ jQuery("#md-assign-box .md-wp-content .md-button-group .md-ignore").addClass("md-active"); }
            if(WPContent == 1){ jQuery("#md-assign-box .md-wp-content .md-button-group .md-include").addClass("md-active"); }
            if(WPContent == 2){ jQuery("#md-assign-box .md-wp-content .md-button-group .md-exclude").addClass("md-active"); }
            var WPContentArray = WPContentVal.split(",");
            if(WPContentVal != '') { jQuery("#md-assign-box .md-wp-content select.wp-content").val(WPContentArray).trigger("chosen:updated"); }
            
            // Home Page
            var homePage = aConf.homePage;
            jQuery("#md-assign-box .md-home-page .md-button-group .md-button").removeClass("md-active");
            if(homePage == 0){ jQuery("#md-assign-box .md-home-page .md-button-group .md-ignore").addClass("md-active"); }
            if(homePage == 1){ jQuery("#md-assign-box .md-home-page .md-button-group .md-include").addClass("md-active"); }
            if(homePage == 2){ jQuery("#md-assign-box .md-home-page .md-button-group .md-exclude").addClass("md-active"); }
            
            // Menu Items
            var menuItems = aConf.menuItems;
            var menuItemsVal = aConf.menuItemsVal + '';
            jQuery("#md-assign-box .md-menu-items .md-button-group .md-button").removeClass("md-active");
            if(menuItems == 0){ jQuery("#md-assign-box .md-menu-items .md-button-group .md-ignore").addClass("md-active"); }
            if(menuItems == 1){ jQuery("#md-assign-box .md-menu-items .md-button-group .md-include").addClass("md-active"); }
            if(menuItems == 2){ jQuery("#md-assign-box .md-menu-items .md-button-group .md-exclude").addClass("md-active"); }
            var menuItemsArray = menuItemsVal.split(",");
            if(menuItemsVal != '') { jQuery("#md-assign-box .md-menu-items select.menuitems").val(menuItemsArray).trigger("chosen:updated"); }
                        
            // URL
            var URL = aConf.URL;
            var URLVal = aConf.URLVal;
            jQuery("#md-assign-box .md-url .md-button-group .md-button").removeClass("md-active");
            if(URL == 0){ jQuery("#md-assign-box .md-url .md-button-group .md-ignore").addClass("md-active"); }
            if(URL == 1){ jQuery("#md-assign-box .md-url .md-button-group .md-include").addClass("md-active"); }
            if(URL == 2){ jQuery("#md-assign-box .md-url .md-button-group .md-exclude").addClass("md-active"); }
            jQuery("#md-assign-box .md-url textarea.md-url-field").val(URLVal);
            
        } catch (e) {
            
            // Reset all controls to default state
            jQuery("#md-assign-box .md-button-group .md-button").removeClass("md-active");
            
            // Matching Method
            jQuery("#md-assign-box .md-matching-method .md-button-group .md-all").addClass("md-active");
            
            // WordPress Content
            jQuery("#md-assign-box .md-wp-content .md-button-group .md-ignore").addClass("md-active");
            jQuery("#md-assign-box .md-wp-content select.wp-content").val("").trigger("chosen:updated");
            
            // Home Page
            jQuery("#md-assign-box .md-home-page .md-button-group .md-ignore").addClass("md-active");
            
            // Menu Items
            jQuery("#md-assign-box .md-menu-items .md-button-group .md-ignore").addClass("md-active");
            jQuery("#md-assign-box .md-menu-items select.menuitems").val("").trigger("chosen:updated");            
                        
            // URL
            jQuery("#md-assign-box .md-url .md-button-group .md-ignore").addClass("md-active");
            jQuery("#md-assign-box .md-url textarea.md-url-field").val("");
            
            console.log(e);
            
        }
        
    }
        
    /**
     * Save settings
     */
    function md_saveSettings() {
        
        /** Get new values */
        
        // Matching Method
        var matchingMethod = 0;
        if(jQuery("#md-assign-box .md-matching-method .md-button-group .md-all").hasClass("md-active")) { matchingMethod = 0; }
        if(jQuery("#md-assign-box .md-matching-method .md-button-group .md-any").hasClass("md-active")) { matchingMethod = 1; }
        //console.log(matchingMethod);
        
        // WordPress Content
        var WPContent = 0;
        if(jQuery("#md-assign-box .md-wp-content .md-button-group .md-ignore").hasClass("md-active")) { WPContent = 0; }
        if(jQuery("#md-assign-box .md-wp-content .md-button-group .md-include").hasClass("md-active")) { WPContent = 1; }
        if(jQuery("#md-assign-box .md-wp-content .md-button-group .md-exclude").hasClass("md-active")) { WPContent = 2; }
        
        var WPContentVal = '';
        if(WPContent){
            WPContentVal = jQuery("#md-assign-box .md-wp-content select.wp-content").val();
        }
        
        // Home Page
        var homePage = 0;
        if(jQuery("#md-assign-box .md-home-page .md-button-group .md-ignore").hasClass("md-active")) { homePage = 0; }
        if(jQuery("#md-assign-box .md-home-page .md-button-group .md-include").hasClass("md-active")) { homePage = 1; }
        if(jQuery("#md-assign-box .md-home-page .md-button-group .md-exclude").hasClass("md-active")) { homePage = 2; }
        
        // Menu Items
        var menuItems = 0;
        if(jQuery("#md-assign-box .md-menu-items .md-button-group .md-ignore").hasClass("md-active")) { menuItems = 0; }
        if(jQuery("#md-assign-box .md-menu-items .md-button-group .md-include").hasClass("md-active")) { menuItems = 1; }
        if(jQuery("#md-assign-box .md-menu-items .md-button-group .md-exclude").hasClass("md-active")) { menuItems = 2; }
        
        var menuItemsVal = '';
        if(menuItems){
            menuItemsVal = jQuery("#md-assign-box .md-menu-items select.menuitems").val();
        }
        
        // URL
        var URL = 0;
        if(jQuery("#md-assign-box .md-url .md-button-group .md-ignore").hasClass("md-active")) { URL = 0; }
        if(jQuery("#md-assign-box .md-url .md-button-group .md-include").hasClass("md-active")) { URL = 1; }
        if(jQuery("#md-assign-box .md-url .md-button-group .md-exclude").hasClass("md-active")) { URL = 2; }
        
        var URLVal = '';
        if(URL){
            URLVal = jQuery("#md-assign-box .md-url textarea.md-url-field").val();
        }        
        
        var aConf = {

            matchingMethod: matchingMethod,
            WPContent: WPContent,
            WPContentVal: WPContentVal,
            homePage: homePage,
            menuItems: menuItems,
            menuItemsVal: menuItemsVal,
            URL: URL,
            URLVal: URLVal
        };
        
        var aConfJson = JSON.stringify(aConf);
        aConfJson = aConfJson.replace(/\"/g, '|');// Input truncate quotes, so made some replacments
        
        assignInput.val(aConfJson);// Set setting to input
        
    }
    
    /**
     * Initialization
     */
    function md_rebarAssignmentIni() {
        
        // Show/Hide unused controls
        jQuery("#md-assign-box .md-button.md-active").click();
        
        // Make select boxes more user-friendly - Chosen
        jQuery("#md-assign-box select.chosen-select").chosen({
            width:'100%',
            search_contains: true,
            disable_search_threshold: 7,
            inherit_select_classes: true,
            no_results_text: "Oops, nothing found"
        });
        
    }
    
    /**
     * Matching Method click
     */
    jQuery("#md-assign-box .md-matchingMethod .md-button").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-matchingMethod button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        md_saveSettings();
    });
    
    /**
     * Menu Items Ignore click
     */
    jQuery("#md-assign-box .md-menu-items .md-button-group .md-ignore").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-menu-items button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery("#md-assign-box .md-menu-items .md-menuitems-selection").hide(200);
        jQuery(this).closest(".md-menu-items").removeClass("md-red md-green");
        md_saveSettings();
    });
    
    /**
     * Menu Items Include click
     */
    jQuery("#md-assign-box .md-menu-items .md-button-group .md-include").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-menu-items button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery("#md-assign-box .md-menu-items .md-menuitems-selection").show(200);
        jQuery(this).closest(".md-menu-items").removeClass("md-red").addClass("md-green");
        md_saveSettings();
    });
    
    /**
     * Menu Items Exclude click
     */
    jQuery("#md-assign-box .md-menu-items .md-button-group .md-exclude").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-menu-items button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery("#md-assign-box .md-menu-items .md-menuitems-selection").show(200);
        jQuery(this).closest(".md-menu-items").removeClass("md-green").addClass("md-red");
        md_saveSettings();
    });
    
    /**
     * Home Page IGNORE click
     */
    jQuery("#md-assign-box .md-home-page .md-button-group .md-ignore").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-home-page .md-button-group button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-home-page").removeClass("md-green md-red");
        md_saveSettings();
    });
    
    /**
     * Home Page INCLUDE click
     */
    jQuery("#md-assign-box .md-home-page .md-button-group .md-include").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-home-page .md-button-group button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-home-page").removeClass("md-red").addClass("md-green");
        md_saveSettings();
    });
    
    /**
     * Home Page EXCLUDE click
     */
    jQuery("#md-assign-box .md-home-page .md-button-group .md-exclude").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-home-page .md-button-group button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-home-page").removeClass("md-green").addClass("md-red");
        md_saveSettings();
    });
       
    /**
     * User URL IGNORE click
     */
    jQuery("#md-assign-box .md-url .md-button-group .md-ignore").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-url button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-url").removeClass("md-green md-red");
        jQuery("#md-assign-box .md-url .md-url-box").hide(200);
        md_saveSettings();
    });
    
    /**
     * User URL INCLUDE click
     */
    jQuery("#md-assign-box .md-url .md-button-group .md-include").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-url button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-url").removeClass("md-red").addClass("md-green");
        jQuery("#md-assign-box .md-url .md-url-box").show(200);
        md_saveSettings();
    });
    
    /**
     * User URL EXCLUDE click
     */
    jQuery("#md-assign-box .md-url .md-button-group .md-exclude").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-url button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-url").removeClass("md-green").addClass("md-red");
        jQuery("#md-assign-box .md-url .md-url-box").show(200);
        md_saveSettings();
    });
    
    /**
     * User WordPress Content IGNORE click
     */
    jQuery("#md-assign-box .md-wp-content .md-button-group .md-ignore").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-wp-content button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-wp-content").removeClass("md-green md-red");
        jQuery("#md-assign-box .md-wp-content .md-wp-content-box").hide(200);
        md_saveSettings();
    });
    
    /**
     * User WordPress Content INCLUDE click
     */
    jQuery("#md-assign-box .md-wp-content .md-button-group .md-include").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-wp-content button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-wp-content").removeClass("md-red").addClass("md-green");
        jQuery("#md-assign-box .md-wp-content .md-wp-content-box").show(200);
        md_saveSettings();
    });
    
    /**
     * User WordPress Content EXCLUDE click
     */
    jQuery("#md-assign-box .md-wp-content .md-button-group .md-exclude").on( 'click', function (e){
        e.preventDefault();
        jQuery("#md-assign-box .md-wp-content button").removeClass("md-active");
        jQuery(this).addClass("md-active");
        jQuery(this).closest(".md-wp-content").removeClass("md-green").addClass("md-red");
        jQuery("#md-assign-box .md-wp-content .md-wp-content-box").show(200);
        md_saveSettings();
    });
    
    /**
     * Seve valeue in field on change
     */
    jQuery("select.wp-content, select.menuitems, textarea.md-url-field").on('input propertychange', function () {
        md_saveSettings();
    });
    
    md_readSettings();
    
    md_rebarAssignmentIni();
    
    
    /** Live preview for styles */
    function md_refresh_preview () {
        jQuery("#md-rebar-wrapper").removeClass().addClass(jQuery("#rebar-style").val());
        jQuery("#md-rebar-element").css("height", jQuery("#md-rebar-height").val() + "px");
        jQuery("#md-rebar-element").css("background-color", jQuery("#md-rebar-color").val());
        jQuery("#md-rebar-element").css("box-shadow", "1px 1px 5px " + jQuery("#md-rebar-color").val());
    }
    
    // Style changed
    jQuery("#rebar-style").change(function () {
        jQuery("#md-rebar-wrapper").removeClass().addClass(jQuery(this).val());
    });
    
    // Height changed
    jQuery("#md-rebar-height").change(function () {
        jQuery("#md-rebar-element").css("height", jQuery(this).val() + "px");
    });
    
    //Color changed
    jQuery("#md-rebar-color").change(function () {
        jQuery("#md-rebar-element").css("background-color", jQuery(this).val());
        jQuery("#md-rebar-element").css( "box-shadow", "1px 1px 5px " + jQuery(this).val() );
    });
    
    md_refresh_preview();

});
